//We would like to download also only once :: when the first startup.

var gBookmarksSynchronizerService=
{
  xbel:null,

  onload:function()
  {
    gBookmarksSynchronizerService._onload();
  },

  onclose:function()
  {
    gBookmarksSynchronizerService._onclose();
  },

  _onload:function()
  {
    this.xbel=new BookmarksSynchronizerXBEL();
    this._addMenu();
    if( this.xbel.settings.getBool("firstload", true) )
    {
      this.xbel.settings.setBool("firstload", false);
      if( this.xbel.settings.getBool("autodownload", false))
        setTimeout(gBookmarksSynchronizerService.download,500);
    }
  },

  _onclose:function()
  {
    try{
      var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                      .getService(Components.interfaces.nsIWindowMediator);
      var browsers=wm.getZOrderDOMWindowEnumerator('navigator:browser',true);
      if(browsers.hasMoreElements())
        var browser=browsers.getNext();
      if(browsers.hasMoreElements())
        return;
    }catch(e){return;}
    this.xbel.settings.setBool("firstload", true);
    if(this.xbel.settings.getBool("autoupload", false))
      this.upload();
  },

  upload:function()
  {
    window.open("chrome://sovereign_browser/content/upload.xul","_blank","chrome,resizable,titlebar=no");
  },

  download:function()
  {
    gBookmarksSynchronizerService.xbel.updateUndoCache();
    window.open("chrome://sovereign_browser/content/download.xul","_blank","chrome,resizable,titlebar=no");
  },

  settings:function()
  {
    window.open("chrome://sovereign_browser/content/sobOptions.xul","_sob_settings_","chrome");
  },

  _addMenu:function()
  {
    try{
      var menu=document.getElementById("bookmarks-menu");
      var popup=menu.firstChild;
      var sep=popup.getElementsByTagName("menuseparator")[0];
      var label=this.xbel.settings.getString("settingslabel");
      var accesskey=this.xbel.settings.getString("settingsaccesskey");
    }catch(e){alert(e); return;}
  
    var  element = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
    element.setAttribute("id", "bookmarks-menuitem-sort");
    element.setAttribute("label", label);
    element.setAttribute("accesskey", accesskey);
    element.setAttribute("oncommand", "gBookmarksSynchronizerService.settings();");
    popup.insertBefore(element,sep);
  },

  unregObserver:function()
  {
    try{
      var bt = document.getElementById("bookmarks-ptf");
      if (!bt && bt.hasAttribute("ref") && bt.ref) 
        bt.database.RemoveObserver(BookmarksToolbarRDFObserver);
    }catch(e){alert(e);}
  },

  regObserver:function()
  {
    try{
      var bt = document.getElementById("bookmarks-ptf");
      if (bt) 
      {
        var btf="rdf:null";
        try{
          btf= BMSVC.getBookmarksToolbarFolder().Value;
        }catch(e){}
        bt.ref=btf;
        document.getElementById("bookmarks-chevron").ref = btf;
        bt.database.AddObserver(BookmarksToolbarRDFObserver);
      }
    }catch(e){ alert(e);}
  }
};

//Event Listeners
window.addEventListener("load", gBookmarksSynchronizerService.onload, false);
window.addEventListener("close", gBookmarksSynchronizerService.onclose, false);
